"""
    Stencila Hub API

    ## Authentication  Many endpoints in the Stencila Hub API require an authentication token. These tokens carry many privileges, so be sure to keep them secure. Do not place your tokens in publicly accessible areas such as client-side code. The API is only served over HTTPS to avoid exposing tokens and other data on the network.  To obtain a token, [`POST /api/tokens`](#operations-tokens-tokens_create) with either a `username` and `password` pair, or an [OpenID Connect](https://openid.net/connect/) token. Then use the token in the `Authorization` header of subsequent requests with the prefix `Token` e.g.      curl -H \"Authorization: Token 48866b1e38a2e9db0baada2140b2327937f4a3636dd5f2dfd8c212341c88d34\" https://hub.stenci.la/api/projects/  Alternatively, you can use `Basic` authentication with the token used as the username and no password. This can be more convenient when using command line tools such as [cURL](https://curl.haxx.se/) e.g.      curl -u 48866b1e38a2e9db0baada2140b2327937f4a3636dd5f2dfd8c212341c88d34: https://hub.stenci.la/api/projects/  Or, the less ubiquitous, but more accessible [httpie](https://httpie.org/):      http --auth 48866b1e38a2e9db0baada2140b2327937f4a3636dd5f2dfd8c212341c88d34: https://hub.stenci.la/api/projects/  In both examples above, the trailing colon is not required but avoids being asked for a password.  ## Versioning  The Stencila Hub is released using semantic versioning. The current version is available from the [`GET /api/status`](/api/status) endpoint. Please see the [Github release page](https://github.com/stencila/hub/releases) and the [changelog](https://github.com/stencila/hub/blob/master/CHANGELOG.md) for details on each release. We currently do not provide versioning of the API but plan to do so soon (probably by using a `Accept: application/vnd.stencila.hub+json;version=1.0` request header). If you are using, or interested in using, the API please contact us and we may be able to expedite this.   # noqa: E501

    The version of the OpenAPI document: v1
    Contact: hello@stenci.la
    Generated by: https://openapi-generator.tech
"""


import re  # noqa: F401
import sys  # noqa: F401

from stencila.hub.model_utils import (  # noqa: F401
    ApiTypeError,
    ModelComposed,
    ModelNormal,
    ModelSimple,
    cached_property,
    change_keys_js_to_python,
    convert_js_args_to_python_args,
    date,
    datetime,
    file_type,
    none_type,
    validate_get_composed_info,
)
from ..model_utils import OpenApiModel
from stencila.hub.exceptions import ApiAttributeError



class JobCreate(ModelNormal):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.

    Attributes:
      allowed_values (dict): The key is the tuple path to the attribute
          and the for var_name this is (var_name,). The value is a dict
          with a capitalized key describing the allowed value and an allowed
          value. These dicts store the allowed enum values.
      attribute_map (dict): The key is attribute name
          and the value is json key in definition.
      discriminator_value_class_map (dict): A dict to go from the discriminator
          variable value to the discriminator class name.
      validations (dict): The key is the tuple path to the attribute
          and the for var_name this is (var_name,). The value is a dict
          that stores validations for max_length, min_length, max_items,
          min_items, exclusive_maximum, inclusive_maximum, exclusive_minimum,
          inclusive_minimum, and regex.
      additional_properties_type (tuple): A tuple of classes accepted
          as additional properties values.
    """

    allowed_values = {
        ('method',): {
            'PARALLEL': "parallel",
            'SERIES': "series",
            'CLEAN': "clean",
            'ARCHIVE': "archive",
            'ZIP': "zip",
            'PULL': "pull",
            'PUSH': "push",
            'EXTRACT': "extract",
            'CONVERT': "convert",
            'PIN': "pin",
            'REGISTER': "register",
            'COMPILE': "compile",
            'BUILD': "build",
            'EXECUTE': "execute",
            'SESSION': "session",
            'SLEEP': "sleep",
        },
        ('status',): {
            'WAITING': "WAITING",
            'DISPATCHED': "DISPATCHED",
            'PENDING': "PENDING",
            'RECEIVED': "RECEIVED",
            'STARTED': "STARTED",
            'RUNNING': "RUNNING",
            'SUCCESS': "SUCCESS",
            'FAILURE': "FAILURE",
            'CANCELLED': "CANCELLED",
            'REVOKED': "REVOKED",
            'TERMINATED': "TERMINATED",
            'REJECTED': "REJECTED",
            'RETRY': "RETRY",
        },
    }

    validations = {
        ('status_message',): {
            'min_length': 1,
        },
        ('summary_string',): {
            'min_length': 1,
        },
        ('runtime_formatted',): {
            'min_length': 1,
        },
        ('children',): {
        },
        ('key',): {
            'max_length': 64,
            'min_length': 1,
        },
        ('worker',): {
            'min_length': 1,
        },
        ('callback_id',): {
            'max_length': 256,
        },
        ('callback_method',): {
            'max_length': 128,
        },
        ('users',): {
        },
        ('anon_users',): {
        },
    }

    @cached_property
    def additional_properties_type():
        """
        This must be a method because a model may have properties that are
        of type self, this must run after the class is loaded
        """
        return (bool, date, datetime, dict, float, int, list, str, none_type,)  # noqa: E501

    _nullable = False

    @cached_property
    def openapi_types():
        """
        This must be a method because a model may have properties that are
        of type self, this must run after the class is loaded

        Returns
            openapi_types (dict): The key is attribute name
                and the value is attribute type.
        """
        return {
            'method': (str,),  # noqa: E501
            'id': (int,),  # noqa: E501
            'status_message': (str,),  # noqa: E501
            'summary_string': (str,),  # noqa: E501
            'runtime_formatted': (str,),  # noqa: E501
            'urls': (str,),  # noqa: E501
            'url': (str,),  # noqa: E501
            'position': (int,),  # noqa: E501
            'children': ([int],),  # noqa: E501
            'params': (bool, date, datetime, dict, float, int, list, str, none_type,),  # noqa: E501
            'key': (str,),  # noqa: E501
            'description': (str, none_type,),  # noqa: E501
            'created': (datetime,),  # noqa: E501
            'updated': (datetime,),  # noqa: E501
            'began': (datetime,),  # noqa: E501
            'ended': (datetime,),  # noqa: E501
            'status': (str,),  # noqa: E501
            'is_active': (bool,),  # noqa: E501
            'result': (bool, date, datetime, dict, float, int, list, str, none_type,),  # noqa: E501
            'error': (bool, date, datetime, dict, float, int, list, str, none_type,),  # noqa: E501
            'log': (bool, date, datetime, dict, float, int, list, str, none_type,),  # noqa: E501
            'runtime': (float,),  # noqa: E501
            'worker': (str,),  # noqa: E501
            'retries': (int,),  # noqa: E501
            'callback_id': (str, none_type,),  # noqa: E501
            'callback_method': (str, none_type,),  # noqa: E501
            'snapshot': (str, none_type,),  # noqa: E501
            'queue': (int,),  # noqa: E501
            'parent': (int, none_type,),  # noqa: E501
            'callback_type': (int, none_type,),  # noqa: E501
            'users': ([int],),  # noqa: E501
            'anon_users': ([str],),  # noqa: E501
        }

    @cached_property
    def discriminator():
        return None


    attribute_map = {
        'method': 'method',  # noqa: E501
        'id': 'id',  # noqa: E501
        'status_message': 'statusMessage',  # noqa: E501
        'summary_string': 'summaryString',  # noqa: E501
        'runtime_formatted': 'runtimeFormatted',  # noqa: E501
        'urls': 'urls',  # noqa: E501
        'url': 'url',  # noqa: E501
        'position': 'position',  # noqa: E501
        'children': 'children',  # noqa: E501
        'params': 'params',  # noqa: E501
        'key': 'key',  # noqa: E501
        'description': 'description',  # noqa: E501
        'created': 'created',  # noqa: E501
        'updated': 'updated',  # noqa: E501
        'began': 'began',  # noqa: E501
        'ended': 'ended',  # noqa: E501
        'status': 'status',  # noqa: E501
        'is_active': 'isActive',  # noqa: E501
        'result': 'result',  # noqa: E501
        'error': 'error',  # noqa: E501
        'log': 'log',  # noqa: E501
        'runtime': 'runtime',  # noqa: E501
        'worker': 'worker',  # noqa: E501
        'retries': 'retries',  # noqa: E501
        'callback_id': 'callbackId',  # noqa: E501
        'callback_method': 'callbackMethod',  # noqa: E501
        'snapshot': 'snapshot',  # noqa: E501
        'queue': 'queue',  # noqa: E501
        'parent': 'parent',  # noqa: E501
        'callback_type': 'callbackType',  # noqa: E501
        'users': 'users',  # noqa: E501
        'anon_users': 'anonUsers',  # noqa: E501
    }

    read_only_vars = {
        'id',  # noqa: E501
        'status_message',  # noqa: E501
        'summary_string',  # noqa: E501
        'runtime_formatted',  # noqa: E501
        'urls',  # noqa: E501
        'url',  # noqa: E501
        'position',  # noqa: E501
        'children',  # noqa: E501
        'created',  # noqa: E501
        'updated',  # noqa: E501
        'began',  # noqa: E501
        'ended',  # noqa: E501
        'status',  # noqa: E501
        'result',  # noqa: E501
        'log',  # noqa: E501
        'runtime',  # noqa: E501
        'worker',  # noqa: E501
        'retries',  # noqa: E501
        'queue',  # noqa: E501
        'users',  # noqa: E501
    }

    _composed_schemas = {}

    @classmethod
    @convert_js_args_to_python_args
    def _from_openapi_data(cls, method, *args, **kwargs):  # noqa: E501
        """JobCreate - a model defined in OpenAPI

        Args:
            method (str):

        Keyword Args:
            _check_type (bool): if True, values for parameters in openapi_types
                                will be type checked and a TypeError will be
                                raised if the wrong type is input.
                                Defaults to True
            _path_to_item (tuple/list): This is a list of keys or values to
                                drill down to the model in received_data
                                when deserializing a response
            _spec_property_naming (bool): True if the variable names in the input data
                                are serialized names, as specified in the OpenAPI document.
                                False if the variable names in the input data
                                are pythonic names, e.g. snake case (default)
            _configuration (Configuration): the instance to use when
                                deserializing a file_type parameter.
                                If passed, type conversion is attempted
                                If omitted no type conversion is done.
            _visited_composed_classes (tuple): This stores a tuple of
                                classes that we have traveled through so that
                                if we see that class again we will not use its
                                discriminator again.
                                When traveling through a discriminator, the
                                composed schema that is
                                is traveled through is added to this set.
                                For example if Animal has a discriminator
                                petType and we pass in "Dog", and the class Dog
                                allOf includes Animal, we move through Animal
                                once using the discriminator, and pick Dog.
                                Then in Dog, we will make an instance of the
                                Animal class but this time we won't travel
                                through its discriminator because we passed in
                                _visited_composed_classes = (Animal,)
            id (int): An autoincrementing integer to allow selecting jobs in the order they were created.. [optional]  # noqa: E501
            status_message (str): [optional]  # noqa: E501
            summary_string (str): [optional]  # noqa: E501
            runtime_formatted (str): [optional]  # noqa: E501
            urls (str): [optional]  # noqa: E501
            url (str): [optional]  # noqa: E501
            position (int): [optional]  # noqa: E501
            children ([int]): [optional]  # noqa: E501
            params (bool, date, datetime, dict, float, int, list, str, none_type): [optional]  # noqa: E501
            key (str): A unique, and very difficult to guess, key to access the job with.. [optional]  # noqa: E501
            description (str, none_type): A short description of the job.. [optional]  # noqa: E501
            created (datetime): The time the job was created.. [optional]  # noqa: E501
            updated (datetime): The time the job was last updated.. [optional]  # noqa: E501
            began (datetime): The time the job began.. [optional]  # noqa: E501
            ended (datetime): The time the job ended.. [optional]  # noqa: E501
            status (str): The current status of the job.. [optional]  # noqa: E501
            is_active (bool): Is the job active?. [optional]  # noqa: E501
            result (bool, date, datetime, dict, float, int, list, str, none_type): The result of the job; a JSON value.. [optional]  # noqa: E501
            error (bool, date, datetime, dict, float, int, list, str, none_type): Any error associated with the job; a JSON object with type, message etc.. [optional]  # noqa: E501
            log (bool, date, datetime, dict, float, int, list, str, none_type): The job log; a JSON array of log objects, including any errors.. [optional]  # noqa: E501
            runtime (float): The running time of the job.. [optional]  # noqa: E501
            worker (str): The identifier of the worker that ran the job.. [optional]  # noqa: E501
            retries (int): The number of retries to fulfil the job.. [optional]  # noqa: E501
            callback_id (str, none_type): The id of the object to call back.. [optional]  # noqa: E501
            callback_method (str, none_type): The name of the method to call back.. [optional]  # noqa: E501
            snapshot (str, none_type): The snapshot that this job is associated with. Usually `session` jobs for the snapshot.. [optional]  # noqa: E501
            queue (int): The queue that this job was routed to. [optional]  # noqa: E501
            parent (int, none_type): The parent job. [optional]  # noqa: E501
            callback_type (int, none_type): The type of the object to call back.. [optional]  # noqa: E501
            users ([int]): Users who have created or connected to the job; not necessarily currently connected.. [optional]  # noqa: E501
            anon_users ([str]): Anonymous users who have created or connected to the job.. [optional]  # noqa: E501
        """

        _check_type = kwargs.pop('_check_type', True)
        _spec_property_naming = kwargs.pop('_spec_property_naming', False)
        _path_to_item = kwargs.pop('_path_to_item', ())
        _configuration = kwargs.pop('_configuration', None)
        _visited_composed_classes = kwargs.pop('_visited_composed_classes', ())

        self = super(OpenApiModel, cls).__new__(cls)

        if args:
            raise ApiTypeError(
                "Invalid positional arguments=%s passed to %s. Remove those invalid positional arguments." % (
                    args,
                    self.__class__.__name__,
                ),
                path_to_item=_path_to_item,
                valid_classes=(self.__class__,),
            )

        self._data_store = {}
        self._check_type = _check_type
        self._spec_property_naming = _spec_property_naming
        self._path_to_item = _path_to_item
        self._configuration = _configuration
        self._visited_composed_classes = _visited_composed_classes + (self.__class__,)

        self.method = method
        for var_name, var_value in kwargs.items():
            if var_name not in self.attribute_map and \
                        self._configuration is not None and \
                        self._configuration.discard_unknown_keys and \
                        self.additional_properties_type is None:
                # discard variable.
                continue
            setattr(self, var_name, var_value)
        return self

    required_properties = set([
        '_data_store',
        '_check_type',
        '_spec_property_naming',
        '_path_to_item',
        '_configuration',
        '_visited_composed_classes',
    ])

    @convert_js_args_to_python_args
    def __init__(self, method, *args, **kwargs):  # noqa: E501
        """JobCreate - a model defined in OpenAPI

        Args:
            method (str):

        Keyword Args:
            _check_type (bool): if True, values for parameters in openapi_types
                                will be type checked and a TypeError will be
                                raised if the wrong type is input.
                                Defaults to True
            _path_to_item (tuple/list): This is a list of keys or values to
                                drill down to the model in received_data
                                when deserializing a response
            _spec_property_naming (bool): True if the variable names in the input data
                                are serialized names, as specified in the OpenAPI document.
                                False if the variable names in the input data
                                are pythonic names, e.g. snake case (default)
            _configuration (Configuration): the instance to use when
                                deserializing a file_type parameter.
                                If passed, type conversion is attempted
                                If omitted no type conversion is done.
            _visited_composed_classes (tuple): This stores a tuple of
                                classes that we have traveled through so that
                                if we see that class again we will not use its
                                discriminator again.
                                When traveling through a discriminator, the
                                composed schema that is
                                is traveled through is added to this set.
                                For example if Animal has a discriminator
                                petType and we pass in "Dog", and the class Dog
                                allOf includes Animal, we move through Animal
                                once using the discriminator, and pick Dog.
                                Then in Dog, we will make an instance of the
                                Animal class but this time we won't travel
                                through its discriminator because we passed in
                                _visited_composed_classes = (Animal,)
            id (int): An autoincrementing integer to allow selecting jobs in the order they were created.. [optional]  # noqa: E501
            status_message (str): [optional]  # noqa: E501
            summary_string (str): [optional]  # noqa: E501
            runtime_formatted (str): [optional]  # noqa: E501
            urls (str): [optional]  # noqa: E501
            url (str): [optional]  # noqa: E501
            position (int): [optional]  # noqa: E501
            children ([int]): [optional]  # noqa: E501
            params (bool, date, datetime, dict, float, int, list, str, none_type): [optional]  # noqa: E501
            key (str): A unique, and very difficult to guess, key to access the job with.. [optional]  # noqa: E501
            description (str, none_type): A short description of the job.. [optional]  # noqa: E501
            created (datetime): The time the job was created.. [optional]  # noqa: E501
            updated (datetime): The time the job was last updated.. [optional]  # noqa: E501
            began (datetime): The time the job began.. [optional]  # noqa: E501
            ended (datetime): The time the job ended.. [optional]  # noqa: E501
            status (str): The current status of the job.. [optional]  # noqa: E501
            is_active (bool): Is the job active?. [optional]  # noqa: E501
            result (bool, date, datetime, dict, float, int, list, str, none_type): The result of the job; a JSON value.. [optional]  # noqa: E501
            error (bool, date, datetime, dict, float, int, list, str, none_type): Any error associated with the job; a JSON object with type, message etc.. [optional]  # noqa: E501
            log (bool, date, datetime, dict, float, int, list, str, none_type): The job log; a JSON array of log objects, including any errors.. [optional]  # noqa: E501
            runtime (float): The running time of the job.. [optional]  # noqa: E501
            worker (str): The identifier of the worker that ran the job.. [optional]  # noqa: E501
            retries (int): The number of retries to fulfil the job.. [optional]  # noqa: E501
            callback_id (str, none_type): The id of the object to call back.. [optional]  # noqa: E501
            callback_method (str, none_type): The name of the method to call back.. [optional]  # noqa: E501
            snapshot (str, none_type): The snapshot that this job is associated with. Usually `session` jobs for the snapshot.. [optional]  # noqa: E501
            queue (int): The queue that this job was routed to. [optional]  # noqa: E501
            parent (int, none_type): The parent job. [optional]  # noqa: E501
            callback_type (int, none_type): The type of the object to call back.. [optional]  # noqa: E501
            users ([int]): Users who have created or connected to the job; not necessarily currently connected.. [optional]  # noqa: E501
            anon_users ([str]): Anonymous users who have created or connected to the job.. [optional]  # noqa: E501
        """

        _check_type = kwargs.pop('_check_type', True)
        _spec_property_naming = kwargs.pop('_spec_property_naming', False)
        _path_to_item = kwargs.pop('_path_to_item', ())
        _configuration = kwargs.pop('_configuration', None)
        _visited_composed_classes = kwargs.pop('_visited_composed_classes', ())

        if args:
            raise ApiTypeError(
                "Invalid positional arguments=%s passed to %s. Remove those invalid positional arguments." % (
                    args,
                    self.__class__.__name__,
                ),
                path_to_item=_path_to_item,
                valid_classes=(self.__class__,),
            )

        self._data_store = {}
        self._check_type = _check_type
        self._spec_property_naming = _spec_property_naming
        self._path_to_item = _path_to_item
        self._configuration = _configuration
        self._visited_composed_classes = _visited_composed_classes + (self.__class__,)

        self.method = method
        for var_name, var_value in kwargs.items():
            if var_name not in self.attribute_map and \
                        self._configuration is not None and \
                        self._configuration.discard_unknown_keys and \
                        self.additional_properties_type is None:
                # discard variable.
                continue
            setattr(self, var_name, var_value)
            if var_name in self.read_only_vars:
                raise ApiAttributeError(f"`{var_name}` is a read-only attribute. Use `from_openapi_data` to instantiate "
                                     f"class with read only attributes.")
